aboutsummaryrefslogtreecommitdiff
path: root/share/hydractl/backup-restore-hidden
diff options
context:
space:
mode:
authorSilvio Rhatto <rhatto@riseup.net>2012-06-27 17:42:21 -0300
committerSilvio Rhatto <rhatto@riseup.net>2012-06-27 17:42:21 -0300
commitf5459b2c4d0781f2ee7c1f0d985aa687413de914 (patch)
treed6f154673b8fabeceb23fa58398b381ad45ec9b4 /share/hydractl/backup-restore-hidden
parent212d5208b39bfc4cf7f7b6ca1fa30a6afed0b7de (diff)
downloadhydra-f5459b2c4d0781f2ee7c1f0d985aa687413de914.tar.gz
hydra-f5459b2c4d0781f2ee7c1f0d985aa687413de914.tar.bz2
Adding backup-restore-hidden
Diffstat (limited to 'share/hydractl/backup-restore-hidden')
-rwxr-xr-xshare/hydractl/backup-restore-hidden79
1 files changed, 79 insertions, 0 deletions
diff --git a/share/hydractl/backup-restore-hidden b/share/hydractl/backup-restore-hidden
new file mode 100755
index 0000000..24cd9bf
--- /dev/null
+++ b/share/hydractl/backup-restore-hidden
@@ -0,0 +1,79 @@
+#!/bin/bash
+#
+# Hidden services backup restoration.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public
+# License along with this program. If not, see
+# <http://www.gnu.org/licenses/>.
+
+# Load.
+source $APP_BASE/lib/hydra/functions || exit 1
+hydra_config_load
+
+# Parameters.
+DATE="`date +%Y%m%d`"
+HIDDEN_DIR="/var/lib/tor/hidden"
+
+# Check restore strategy.
+if [ "$1" == "localhost" ] || [ "$1" == "`facter hostname`" ]; then
+ hydra_backup_environment_local
+else
+ hydra_backup_environment_remote $1 restore
+fi
+
+# Check if folder exist on the backup.
+if [ ! -d "$RESTOREDIR/$HIDDEN_DIR" ]; then
+ echo "Hidden services folder does not exist: $RESTOREDIR/$HIDDEN_DIR"
+ exit 1
+fi
+
+# Set git user.
+if hydra_check_user debian-tor; then
+ HIDDEN_USER="debian-tor"
+else
+ HIDDEN_USER="root"
+fi
+
+# Set git group.
+if hydra_check_group debian-tor; then
+ HIDDEN_GROUP="debian-tor"
+else
+ HIDDEN_GROUP="root"
+fi
+
+# TODO: Backup it?
+#hydractl backup-hidden
+
+# Restore hidden service folder from backup.
+#
+# Symlink creation on site instances like drupal should be done
+# already by backup-restore-site.
+for folder in `ls $RESTOREDIR/$HIDDEN_DIR`; do
+ if [ -e "$HIDDEN_DIR/$folder/hostname" ]; then
+ # A hidden service already exists
+ if ! diff "$HIDDEN_DIR/$folder/hostname" "$RESTOREDIR/$HIDDEN_DIR/$folder/hostname" &> /dev/null; then
+ # They're different hidden services!
+ echo "Hidden service $hidden already exist on $HIDDEN_DIR/$folder and differs from backup!"
+ echo "Please fix this conflict manually and restore backups again."
+ else
+ echo "Hidden service $hidden already in place, no need to copy."
+ fi
+ else
+ rm -rf $HIDDEN_DIR/$folder
+ cp -a $RESTOREDIR/$HIDDEN_DIR/$folder $HIDDEN_DIR/$folder
+ fi
+done
+
+# Fix permissions.
+chown -R $HIDDEN_USER.$HIDDEN_GROUP $HIDDEN_DIR
+